import _createClass from "@babel/runtime/helpers/esm/createClass";
import redis from 'redis';
import redisMock from 'redis-mock';

var RedisClient = /*#__PURE__*/function () {
  function RedisClient(_ref) {
    var redisConnection = _ref.redisConnection;
    this._redisClient = process.env.USE_REDIS_IN_SUI_DECORATORS_CACHE ? redis.createClient({
      port: redisConnection.port,
      host: redisConnection.host,
      enable_offline_queue: false,
      retry_strategy: function retry_strategy(options) {
        return Math.min(options.attempt * 100, 3000);
      }
    }) : redisMock.createClient();

    this._redisClient.on('error', function () {
      console.error("[sui-decorators/cache]:RedisClient Error creating Redis client");
    });
  }

  RedisClient.getInstance = function getInstance(_ref2) {
    var _ref2$redisConnection = _ref2.redisConnection,
        redisConnection = _ref2$redisConnection === void 0 ? {
      host: '127.0.0.1',
      port: 6379
    } : _ref2$redisConnection;

    if (!RedisClient.instance) {
      RedisClient.instance = new RedisClient({
        redisConnection: redisConnection
      });
    }

    return RedisClient.instance;
  };

  _createClass(RedisClient, [{
    key: "client",
    get: function get() {
      return this._redisClient;
    }
  }]);

  return RedisClient;
}();

RedisClient.instance = void 0;
export { RedisClient as default };